/**********************************************************************
// 
//  PIC18F2525.
// Mplab 8.91    8 v.1.2
																								 
**********************************************************************/

/***********************************************************************
      10-   
.
                     PORTC
                    bgch afed          PORTC
  0 - a,b,c,d,e,f   0101 0000         50
  1- b,c            0101 1111         5F
  2 - a,b,g,e,d     0011 0100         34
  3 - a,b,c,d,g     0001 0110         16
  4 - b,c,f,g       0001 1011        1B
  5 - a,c,d,f,g     1001 0010        92
  6 - a,d,c,e,f,g   1001 0000         90
  7 - a,b,c         0101 0111         57
  8 - a,b,c,d,e,f,g 0001 0000        10
  9 - a,b,c,d,f,g   0001 0010         12
  PORTB
1 - 0x01
2-  0x08
3 - 0x10
4 - 0x02
5 - 0x80
6 - 0x40
7 - 0x20
8 - 0x04
F = F/8.
   1    8
 n_tmr1 = F/(65536 * 8)     
 Tmr1_in = 65536 - (F/(n_tmr1 * 8))   1.
        ,  Tmr1_in   .

                                                                          */
/**********************************************************************

**********************************************************************/

/** C O N F I G U R A T I O N   B I T S PIC18F2525**************/

#pragma config OSC = HS, FCMEN = OFF, IESO = OFF             // CONFIG1H
#pragma config PWRT = OFF                // CONFIG2L
#pragma config WDT = ON, WDTPS = 32768                        // CONFIG2H
#pragma config MCLRE = OFF, LPT1OSC = OFF, PBADEN = ON, CCP2MX = PORTC//CONF3H
#pragma config STVREN = ON, LVP = OFF, XINST = OFF               // CONFIG4L
#pragma config CP0 = OFF, CP1 = OFF, CP2 = OFF        // CONFIG5L
#pragma config CPB = OFF, CPD = OFF                              // CONFIG5H
#pragma config WRT0 = OFF, WRT1 = OFF, WRT2 = OFF    // CONFIG6L
#pragma config WRTB = OFF, WRTC = OFF, WRTD = OFF                // CONFIG6H
#pragma config EBTR0 = OFF, EBTR1 = OFF, EBTR2 = OFF// CONFIG7L
#pragma config EBTRB = OFF                                       // CONFIG7H
/** I N C L U D E S **************************************************/
#include <pic18f2525.h>
#include <htc.h>
#define _XTAL_FREQ  10000000
#define   Freq_Pin     PORTA4   // 
#define   Count        LATA0     // 
#define   F_dop        LATA1     //


//-------------------------------------------------------------------------------------------
const unsigned char iDC7[10] = {0x50, 0x5F, 0x34, 0x16, 0x1B, 0x92, 0x90, 0x57, 0x10, 0x12};
void Init_CPU( void );
void interrupt clock_isr( void );

unsigned char Freq[8];
unsigned long Freq_F;
volatile unsigned int counter;
const unsigned int Tmr1_in = 2997; //   10 
unsigned char fdop, Tmr0_old, n_tmr1, Ind;
unsigned char i, Flag, Flag_D;


/* =================================================
  
 ===================================================  */

/* =================================================
   
 ===================================================  */
void interrupt clock_isr( void )
{
  if ( TMR0IF & TMR0IE )
   {
      counter ++;
      TMR0IF = 0;
   }
  if ( TMR1IF & TMR1IE )
   {
      n_tmr1--;

      if ( !n_tmr1 )     //   
      {
	      Count = 0;
          TMR1ON = 0;
         Flag = 1;
      }

      TMR1IF = 0;
      TMR1 = Tmr1_in;
   }
   

    if ( TMR3IE && TMR3IF )
   {
      TMR3 = 59285;   //2,5 
      Ind++;
	  Flag_D = 1;
      TMR3IF = 0;
   }
}

/* =================================================
  
 ===================================================  */
void Init_CPU( void )
{
   TRISA = 0b11010000;                // , 6,7,4-.
   TRISB = 0;                         // .
   TRISC = 0;                         // .
   //WPUA =  0;                       //
   //   .
   ADCON1 = 0b00001111;                        //
   ADCON0 = 0;                        //
   ADCON2 = 0;                        //
   LATA = 0x03;
   LATB = 0;
   LATC = 0;
   CMCON = 0x07;                      // .
   INTCON = 0; //0b10001000;          //  
   T0CON = 0b11100111; //0b10100011;                //8-,   256
   //  Timer
    T1CON = 0b10110001;                // 1:8
   T3CON =  0b10000001;               //16-,  
   //  USART
   BAUDCON = 0;
   SPBRG = 25;                // (25) uart 9600 baund BRGH=0,103-(BRGH = 1)
   BRGH = 0;                 // (0)data rate for sending
   BRG16 = 0;                 // (0)data rate for sending
   SYNC = 0;                 //asynchronous
   SPEN = 0;                 //enable serial port pins
   CREN = 0;                 //enable reception
   TX9 = 0;                  //8-bit transmission
   TXEN = 0;                 //enable the transmitter
   RX9  = 0;                 //8-bit reception
   ADDEN  = 0;               //  
   //    
   IPEN = 0;            //enable priority levels
   PEIE  = 1;                         //   
   RCIE  = 0;                         //   uart
   RCIP = 0;                          // 
   RBIE = 0;                          //    PORTB
   TMR1IE = 1;                        //    TMR1
   TMR0IE = 1;                        //    TMR0
   TMR3IE = 1;                        //    TMR0
   GIEH  = 1;                         //  
 }


//********************************************
// *********************************************************************
//                        Main
// **********************************************************************
void main( void )
{
   
   n_tmr1 = 5;         // 1 
   TMR1 = Tmr1_in; //1459;         // 1 
    Ind = 0;
   
   Init_CPU();

   while ( 1 )
   {
      CLRWDT();
	
	 //******************************************************************************
      //   
      //******************************************************************************
	   if ( Flag_D ) 
	 {
      if ( Ind > 7 )
      {
         Ind = 0;
      }

      switch ( Ind )
      {
         case 0:
            if ( Freq[7] )
            {
               LATC = ( iDC7[Freq[7]] );
               LATB = 0x01;
            }
            else
            {
               LATB = 0x00;           //   0
            }
            break;

         case 1:
            if ( !Freq[6] && !Freq[7] )
            {
               LATB = 0x00;
            }
            else
            {
               LATC = ( iDC7[Freq[6]] & 0xEF )  ;  // 
               LATB = 0x08;
            }
            break;

         case 2:
            if ( !Freq[5] && !Freq[6] && !Freq[7] )   //   0
            {
               LATB = 0x00;
            }
            else
            {
               LATC = ( iDC7[Freq[5]] );
               LATB = 0x10;
            }
            break;

         case 3:
            if ( !Freq[4] && !Freq[5] && !Freq[6] && !Freq[7] )  //   0
            {
               LATB = 0x00;
            }
            else
            {
               LATC = ( iDC7[Freq[4]] );
               LATB = 0x02;
            }
            break;

         case 4:
            LATC = ( iDC7[Freq[3]] & 0xEF ); // 
            LATB = 0x80;
            break;

         case 5:
            LATC = ( iDC7[Freq[2]] );
            LATB = 0x40;
            break;

         case 6:
            LATC = ( iDC7[Freq[1]] );
            LATB = 0x20;
            break;

         case 7:
            LATC = ( iDC7[Freq[0]] );
            LATB = 0x04;
            break;
      } 
       Flag_D = 0;
	  } 
       if ( Flag )
      {
         Tmr0_old = TMR0;
         GIEH  = 0;  
         while ( Tmr0_old == TMR0 )
         {
            F_dop = 0;
            asm( "nop" ) ;
            asm( "nop" ) ;
            F_dop = 1;
            asm( "nop" ) ;
            asm( "nop" ) ;
            fdop ++;
         }

         fdop = ( 256 - fdop );
		  GIEH  = 1;
		 Freq_F =(( counter * 65536 ) + (unsigned int)( Tmr0_old << 8 ) + (unsigned char)fdop);
                 
         for ( i = 0; i < 8; i++ )
         {
            if ( i == 7 )
            {
               Freq[7] = Freq_F;
            }
            else
            {
               Freq[i] = Freq_F % 10;
               Freq_F /= 10;
            }
         }

        
         TMR0 = 0;
         fdop = 0;
         counter = 0;
         Flag = 0;
         n_tmr1 = 5;
         TMR1 = Tmr1_in;
         TMR1ON = 1;
         Count = 1;
      }
    
   }
}



